unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, Math, ExtCtrls;

type
  TForm1 = class(TForm)
    Timer1: TTimer;
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

type TKeys = record

  Left:boolean;
  Right:boolean;
  Up:boolean;
  Down:boolean;
  Fire:boolean;

end;

type TPlayer = record
    Pos:TPoint;
    Dir:integer;
    Life:integer;
    Fire:integer;
    Keys:TKeys;
  end;

type TBullet = record
    Pos:TPoint;
    Dir:integer;
    Del:boolean;
  end;

var
  Form1: TForm1;
  Players:array[0..1] of TPlayer;
  Bullets:array of TBullet;

function Move(Pos:TPoint;Dir:integer;c:integer):TPoint;
function Range(A:TPoint;B:TPoint):integer;

implementation

{$R *.dfm}

function Move(Pos:TPoint;Dir:integer;c:integer):TPoint;
begin
  Result.X:=Pos.X+Trunc(Cos(DegToRad(Dir))*c);
  Result.Y:=Pos.Y-Trunc(Sin(DegToRad(Dir))*c);
end;

function Range(A:TPoint;B:TPoint):integer;
begin
  Result:=Trunc( Sqrt( Sqr( A.X - B.X ) + Sqr( A.Y - B.Y ) ) );
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin

  case Key of // zmienna Key zawiera numer wcinitego klawisza

    //cyfra przed dwukropkiem okrela warto w zmiennej Key
    //przy ktrej instrukcja za dwukropkiem zostanie wykonana

    //klawisze pierwszego gracza: WSAD + spacja
    87:Players[0].Keys.Up:=true;    // klawisz W wcza ruch do przodu
    83:Players[0].Keys.Down:=true;  // klawisz S wcza ruch do tyu
    65:Players[0].Keys.Left:=true;  // klawisz A wcza skrcanie w lewo
    68:Players[0].Keys.Right:=true; // klawisz D wcza skrcanie w prawo
    32:Players[0].Keys.Fire:=true;  // spacja wcza strzelanie
    
    //klawisze drugiego gracza: klawiatura numeryczna 4568 + enter
    //wpisane niej kody oznaczaj cyfry a nie klawisze funkcyjne
    //wic NumLock musi by wczony
    //kod 13 odpowiada obu enter'om
    104:Players[1].Keys.Up:=true;    // klawisz 8 wcza ruch do przodu
    101:Players[1].Keys.Down:=true;  // klawisz 5 wcza ruch do tyu
    100:Players[1].Keys.Left:=true;  // klawisz 4 wcza skrcanie w lewo
    102:Players[1].Keys.Right:=true; // klawisz 6 wcza skrcanie w prawo
    13 :Players[1].Keys.Fire:=true;  // enter wcza strzelanie 

  end; // koniec case'a

end;

procedure TForm1.FormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin

  case Key of // zmienna Key zawiera numer wcinitego klawisza

    //klawisze pierwszego gracza: WSAD + spacja
    87:Players[0].Keys.Up:=false;    // klawisz W wycza ruch do przodu
    83:Players[0].Keys.Down:=false;  // klawisz S wycza ruch do tyu
    65:Players[0].Keys.Left:=false;  // klawisz A wycza skrcanie w lewo
    68:Players[0].Keys.Right:=false; // klawisz D wycza skrcanie w prawo
    32:Players[0].Keys.Fire:=false;  // spacja wycza strzelanie

    //klawisze drugiego gracza: klawiatura numeryczna 4568 + enter
    //wpisane niej kody oznaczaj cyfry a nie klawisze funkcyjne
    //wic NumLock musi by wczony
    //kod 13 odpowiada obu enter'om
    104:Players[1].Keys.Up:=false;    // klawisz 8 wycza ruch do przodu
    101:Players[1].Keys.Down:=false;  // klawisz 5 wycza ruch do tyu
    100:Players[1].Keys.Left:=false;  // klawisz 4 wycza skrcanie w lewo
    102:Players[1].Keys.Right:=false; // klawisz 6 wycza skrcanie w prawo
    13 :Players[1].Keys.Fire:=false;  // enter wycza strzelanie

  end; // koniec case'a

end;

procedure TForm1.Timer1Timer(Sender: TObject);
var
  i,j:integer;
begin

  Form1.Canvas.Brush.Color:=clBtnFace;
  Form1.Canvas.FillRect(Rect(0,0,Form1.ClientWidth,Form1.ClientHeight));


  if Length(Bullets)<>0 then
  begin

    for i:=0 to High(Bullets) do
    begin

      Bullets[i].Pos:=Move(Bullets[i].Pos,Bullets[i].Dir,20);
      
      if (Bullets[i].Pos.X<0) or (Bullets[i].Pos.Y<0) then
        Bullets[i].Del:=true;

      if (Bullets[i].Pos.X>Form1.ClientWidth) or (Bullets[i].Pos.Y>Form1.ClientHeight) then
        Bullets[i].Del:=true;

      for j:=0 to 1 do
      begin

      	if Range(Players[j].Pos,Bullets[i].Pos)<=16 then
        begin

          Bullets[i].Del:=true;
          Dec(Players[j].Life,5);

        end;

      end;

    end;

  end;

  i:=0;
          
  Form1.Canvas.Brush.Color:=clYellow;

  while i<Length(Bullets) do
  begin
  
    if Bullets[i].Del then
    begin

      if i=High(Bullets) then
        SetLength(Bullets,Length(Bullets)-1)
      else
      begin

        Bullets[i]:=Bullets[High(Bullets)];
        SetLength(Bullets,Length(Bullets)-1);
        Dec(i);

      end;

    end
    else
    begin

      Form1.Canvas.Ellipse(Bullets[i].Pos.X-3,Bullets[i].Pos.Y-3,Bullets[i].Pos.X+3,Bullets[i].Pos.Y+3);

    end;

    Inc(i)

  end;
         
  Form1.Canvas.Brush.Color:=clBlue;

  for i:=0 to 1 do
  begin

    if Players[i].Keys.Left then
      Inc(Players[i].Dir,10);

    if Players[i].Keys.Right then
      Dec(Players[i].Dir,10);

    if Players[i].Keys.Up then
      Players[i].Pos:=Move(Players[i].Pos,Players[i].Dir,10);

    if Players[i].Keys.Down then
      Players[i].Pos:=Move(Players[i].Pos,Players[i].Dir,-5);

    if Players[i].Fire=0 then
    begin

      if Players[i].Keys.Fire then
      begin

        SetLength(Bullets,Length(Bullets)+1);
        Bullets[High(Bullets)].Pos:=Move(Players[i].Pos,Players[i].Dir,20);
        Bullets[High(Bullets)].Dir:=Players[i].Dir;

        Players[i].Fire:=2;
        
      end;
    end
    else
      Dec(Players[i].Fire);

    if Players[i].Life<=0 then
    begin

      Randomize();
      Players[i].Pos.X:=Random(Form1.ClientWidth-32)+16;
      Players[i].Pos.Y:=Random(Form1.ClientHeight-32)+16; 
      Players[i].Life:=100;

    end;
    
    Form1.Canvas.Ellipse(Players[i].Pos.X-16,Players[i].Pos.Y-16,Players[i].Pos.X+16,Players[i].Pos.Y+16);

  end;

end;

end.
 